/* eSchemes Deluxe Installation Procedure */

/* 1.   DLL  뢠  unlock  , 
         -  IBMLANLK.EXE */

/* 㦠 SysUtils */
CALL RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
CALL SysLoadFuncs

/* ।塞 ⥬ ⠫  ᪨ */

/* ६ ⠫ */
temp = STRIP(VALUE('TEMP',,'OS2ENVIRONMENT'))
if temp='' then
do
  temp = STRIP(VALUE('TMP',,'OS2ENVIRONMENT'))
  if temp='' then
  do
    errmsg='Environment variable TEMP or TMP not set.'
    signal error
  end
end

If \Rxfuncquery('SysBootDrive') Then
do
  bootdrive = SysBootDrive()
end
else
do
  parse upper value VALUE( "PATH",, "OS2ENVIRONMENT" ) with "\OS2\SYSTEM" -2, bootdrive +2
  if bootdrive = '' then
  do
    errmsg='Can not detect boot drive. Please update REXXUTIL.DLL.'
    signal error
  end
end

/* ⠫  樮 */
osdir = STRIP(VALUE('OSDIR',,'OS2ENVIRONMENT'))
if osdir='' then
do
  call say_log 'IBM OS/2 or eComStation 1.0 detected'
  OS="OS2"
  osdir=bootdrive||'\OS2'
end
else
do
  call say_log 'eComStation 1.1 or higher detected'
  OS="ECS"
end

c = SUBSTR(osdir, 1, 1)
backdir = osdir||'\INSTALL\BACKUP'
'@if not exist '||backdir||' md '||backdir
backdir = osdir||'\INSTALL\BACKUP\ESCHEMES'
'@if not exist '||backdir||' md '||backdir
backdir = osdir||'\INSTALL\BACKUP\ESCHEMES\'||DATE('S')||TIME('S')
'@if not exist '||backdir||' md '||backdir

/* ।塞 ⠫  㬥 */
mmbase = STRIP(VALUE('MMBASE',,'OS2ENVIRONMENT'))
parse value mmbase with mmbase ';'

if mmbase='' then mmbase=c||':\MMOS2'

/*  ᯨ᮪ 䠩,  㤥 ⠭ */
tmp=temp||'\deluxe.tmp'
tmp2=temp||'\deluxe2.cmd'
'@dir /b *.dll  > '||tmp

/* 塞,   ࠥ */
do while lines(tmp)>0
  s=linein(tmp)
  mmdir=mmbase||'\DLL\'
  rc=lineout(tmp2,'@if exist "'||mmdir||s||'" copy "'||mmdir||s||'" "'||backdir||'\'||s||'" > nul')
end
rc=lineout(tmp2,'@copy "'||mmbase||'\MMPMMMIO.INI" "'||backdir||'\MMPMMMIO.INI" > nul')
rc=stream(tmp2,'c','close')
rc=stream(tmp,'c','close')

/*  १ࢭ  */
'@call '||tmp2
'@if exist '||tmp2||' del '||tmp2
'@if exist '||tmp||' del '||tmp

'@unlock '||mmbase||'\dll\*io.dll >nul'
'@unlock '||mmbase||'\dll\zcodec.dll >nul'
'@unlock '||osdir||'\dll\wpimgex.dll >nul'
'@unlock '||osdir||'\dll\wpobjex.dll >nul'
'@unlock '||osdir||'\dll\wpfldrex.dll >nul'
'@unlock '||osdir||'\dll\wppdf.dll >nul'
'@unlock '||osdir||'\dll\wpdfex.dll >nul'
'@unlock '||osdir||'\dll\ecolange.dll >nul'
'@unlock '||osdir||'\dll\ecomedia.dll >nul'

/* ।塞,   MINSTALL    ⥬ */
rep=temp||'\rep.tmp'

'@bldlevel '||mmbase||'\minstall.exe > '||rep
do while lines(rep)>0
  s=linein(rep)
  parse value s with Key ':' Value
  If strip(key)='Vendor' then leave
end

rc=stream(rep,'c','close')
'@if exist '||rep||' del '||rep

z=directory();
curdir=''
do p=1 to length(z)
  l=substr(z, p, 1)
  if l='\' then
    curdir=curdir||'\\'
  else
    curdir=curdir||l
end

mmdir=''
if substr(mmbase, length(mmbase))='\' then mmbase=substr(mmbase, 1, length(mmbase)-1)
do p=1 to length(mmbase)
  l=substr(mmbase, p, 1)
  if l='\' then
    mmdir=mmdir||'\\'
  else
    mmdir=mmdir||l
end

/* 㥬 䠩 ⢥⮢ */

/* ந⥫ - KIEWITZ*/
if strip(value)='KIEWITZ' then
do
call say_log 'MINSTALL by KIEWITZ'
rc=lineout(rep, 'MMINSTALL = ( ')
rc=lineout(rep, '   SOURCE = "'||curdir||'"')
rc=lineout(rep, '   TARGET = "'||mmdir||'"')
rc=lineout(rep, '   TARGETBOOT = ""')
rc=lineout(rep, '   GROUPS[23] = (')
rc=lineout(rep, '      ( GROUPID    = 1')
rc=lineout(rep, '        CUSTOMDATA = ""')
rc=lineout(rep, '      )')
rc=lineout(rep, '      ( GROUPID    = 2')
rc=lineout(rep, '        CUSTOMDATA = ""')
rc=lineout(rep, '      )')
rc=lineout(rep, '      ( GROUPID    = 3')
rc=lineout(rep, '        CUSTOMDATA = ""')
rc=lineout(rep, '      )')
rc=lineout(rep, '      ( GROUPID    = 5')
rc=lineout(rep, '        CUSTOMDATA = ""')
rc=lineout(rep, '      )')
rc=lineout(rep, '      ( GROUPID    = 6')
rc=lineout(rep, '        CUSTOMDATA = ""')
rc=lineout(rep, '      )')
rc=lineout(rep, '      ( GROUPID    = 7')
rc=lineout(rep, '        CUSTOMDATA = ""')
rc=lineout(rep, '      )')
rc=lineout(rep, '      ( GROUPID    = 8')
rc=lineout(rep, '        CUSTOMDATA = ""')
rc=lineout(rep, '      )')
rc=lineout(rep, '      ( GROUPID    = 9')
rc=lineout(rep, '        CUSTOMDATA = ""')
rc=lineout(rep, '      )')
rc=lineout(rep, '      ( GROUPID    = 10')
rc=lineout(rep, '        CUSTOMDATA = ""')
rc=lineout(rep, '      )')
rc=lineout(rep, '      ( GROUPID    = 11')
rc=lineout(rep, '        CUSTOMDATA = ""')
rc=lineout(rep, '      )')
rc=lineout(rep, '      ( GROUPID    = 12')
rc=lineout(rep, '        CUSTOMDATA = ""')
rc=lineout(rep, '      )')
rc=lineout(rep, '      ( GROUPID    = 13')
rc=lineout(rep, '        CUSTOMDATA = ""')
rc=lineout(rep, '      )')
rc=lineout(rep, '      ( GROUPID    = 14')
rc=lineout(rep, '        CUSTOMDATA = ""')
rc=lineout(rep, '      )')
rc=lineout(rep, '      ( GROUPID    = 15')
rc=lineout(rep, '        CUSTOMDATA = ""')
rc=lineout(rep, '      )')
rc=lineout(rep, '      ( GROUPID    = 16')
rc=lineout(rep, '        CUSTOMDATA = ""')
rc=lineout(rep, '      )')
rc=lineout(rep, '      ( GROUPID    = 17')
rc=lineout(rep, '        CUSTOMDATA = ""')
rc=lineout(rep, '      )')
rc=lineout(rep, '      ( GROUPID    = 18')
rc=lineout(rep, '        CUSTOMDATA = ""')
rc=lineout(rep, '      )')
rc=lineout(rep, '      ( GROUPID    = 19')
rc=lineout(rep, '        CUSTOMDATA = ""')
rc=lineout(rep, '      )')
rc=lineout(rep, '      ( GROUPID    = 21')
rc=lineout(rep, '        CUSTOMDATA = ""')
rc=lineout(rep, '      )')
rc=lineout(rep, '      ( GROUPID    = 22')
rc=lineout(rep, '        CUSTOMDATA = ""')
rc=lineout(rep, '      )')
rc=lineout(rep, '      ( GROUPID    = 23')
rc=lineout(rep, '        CUSTOMDATA = ""')
rc=lineout(rep, '      )')
rc=lineout(rep, '      ( GROUPID    = 24')
rc=lineout(rep, '        CUSTOMDATA = ""')
rc=lineout(rep, '      )')
rc=lineout(rep, '      ( GROUPID    = 25')
rc=lineout(rep, '        CUSTOMDATA = ""')
rc=lineout(rep, '      )')
rc=lineout(rep, '    )')
rc=lineout(rep, ' )')
end
else
/* ந⥫ - IBM */
if strip(value)='IBM' then
do
call say_log 'MINSTALL by IBM'
rc=lineout(rep, 'MMINSTSOURCE = "'||curdir||'"')
rc=lineout(rep, 'MMINSTTARGET = "'||c||':"')
rc=lineout(rep, 'CHANGECONFIG = "Y"')
rc=lineout(rep, '')
rc=lineout(rep, 'MMINSTGROUPS =')
rc=lineout(rep, '   (')
rc=lineout(rep, '   GROUP.1 = " "')
rc=lineout(rep, '   GROUP.2 = " "')
rc=lineout(rep, '   GROUP.3 = " "')
rc=lineout(rep, '   GROUP.5 = " "')
rc=lineout(rep, '   GROUP.6 = " "')
rc=lineout(rep, '   GROUP.7 = " "')
rc=lineout(rep, '   GROUP.8 = " "')
rc=lineout(rep, '   GROUP.9 = " "')
rc=lineout(rep, '   GROUP.10 = " "')
rc=lineout(rep, '   GROUP.11 = " "')
rc=lineout(rep, '   GROUP.12 = " "')
rc=lineout(rep, '   GROUP.13 = " "')
rc=lineout(rep, '   GROUP.14 = " "')
rc=lineout(rep, '   GROUP.15 = " "')
rc=lineout(rep, '   GROUP.16 = " "')
rc=lineout(rep, '   GROUP.17 = " "')
rc=lineout(rep, '   GROUP.18 = " "')
rc=lineout(rep, '   GROUP.19 = " "')
rc=lineout(rep, '   GROUP.20 = " "')
rc=lineout(rep, '   GROUP.21 = " "')
rc=lineout(rep, '   GROUP.22 = " "')
rc=lineout(rep, '   GROUP.23 = " "')
rc=lineout(rep, '   GROUP.24 = " "')
rc=lineout(rep, '   GROUP.25 = " "')
rc=lineout(rep, '   )')
end
else
  call say_log 'Error! Unknown MINSTALL version'

rc=stream(rep,'c','close')

z=substr(osdir, 3);
odir=''
do p=1 to length(z)
  l=substr(z, p, 1)
  if l='\' then
    odir=odir||'\\'
  else
    odir=odir||l
end

'@if exist control.scr @del control.scr>nul'
rc=lineout('control.scr', 'package="MMIMAGE"');
rc=lineout('control.scr', 'codepage=850');
rc=lineout('control.scr', 'filelist="IO.LST"');
rc=lineout('control.scr', 'groupcount=23');
rc=lineout('control.scr', 'munitcount=1');
rc=lineout('control.scr', 'medianame="MMImage Pak"');
rc=lineout('control.scr', '');
rc=lineout('control.scr', 'destindir = "\\MMOS2\\INSTALL\\"          = 0');
rc=lineout('control.scr', 'destindir = "\\MMOS2\\DLL\\"              = 1');
rc=lineout('control.scr', 'destindir = "'||odir||'\\DLL\\"           = 2');
/* !!!!!!!! */
rc=lineout('control.scr', 'destindir = "'||odir||'\\LANG\\"          = 3');
rc=lineout('control.scr', '');
rc=lineout('control.scr', 'ssgroup=1');
rc=lineout('control.scr', 'ssname="PNG I/O Procedure"');
rc=lineout('control.scr', 'sssize=70');
rc=lineout('control.scr', 'ssversion="1.9.0"');
rc=lineout('control.scr', 'ssselect="YES"');
rc=lineout('control.scr', 'ssconfigch="MMIMAGE.SCR"');
rc=lineout('control.scr', 'ssinich="IOPNG.SCR"');
rc=lineout('control.scr', '');
rc=lineout('control.scr', 'ssgroup=3');
rc=lineout('control.scr', 'ssname="JPEG I/O Procedure"');
rc=lineout('control.scr', 'sssize=70');
rc=lineout('control.scr', 'ssversion="0.3.0"');
rc=lineout('control.scr', 'ssselect="YES"');
rc=lineout('control.scr', 'ssconfigch="MMIMAGE.SCR"');
rc=lineout('control.scr', 'ssinich="IOJPG.SCR"');
rc=lineout('control.scr', '');
rc=lineout('control.scr', 'ssgroup=5');
rc=lineout('control.scr', 'ssname="Z (zlib) Codec"');
rc=lineout('control.scr', 'sssize=70');
rc=lineout('control.scr', 'ssversion="1.0.0"');
rc=lineout('control.scr', 'ssselect="YES"');
rc=lineout('control.scr', 'ssconfigch="MMIMAGE.SCR"');
rc=lineout('control.scr', 'ssinich="ZCODEC.SCR"');
rc=lineout('control.scr', '');
rc=lineout('control.scr', 'ssgroup=6');
rc=lineout('control.scr', 'ssname="X Window Bitmap I/O Procedure"');
rc=lineout('control.scr', 'sssize=70');
rc=lineout('control.scr', 'ssversion="1.0.0"');
rc=lineout('control.scr', 'ssselect="YES"');
rc=lineout('control.scr', 'ssconfigch="MMIMAGE.SCR"');
rc=lineout('control.scr', 'ssinich="IOXBM.SCR"');
rc=lineout('control.scr', '');
rc=lineout('control.scr', 'ssgroup=7');
rc=lineout('control.scr', 'ssname="Portable Pixel-map I/O Procedure"');
rc=lineout('control.scr', 'sssize=70');
rc=lineout('control.scr', 'ssversion="1.0.0"');
rc=lineout('control.scr', 'ssselect="YES"');
rc=lineout('control.scr', 'ssconfigch="MMIMAGE.SCR"');
rc=lineout('control.scr', 'ssinich="IOPPM.SCR"');
rc=lineout('control.scr', '');
rc=lineout('control.scr', 'ssgroup=8');
rc=lineout('control.scr', 'ssname="Portable Greymap I/O Procedure"');
rc=lineout('control.scr', 'sssize=70');
rc=lineout('control.scr', 'ssversion="1.0.0"');
rc=lineout('control.scr', 'ssselect="YES"');
rc=lineout('control.scr', 'ssconfigch="MMIMAGE.SCR"');
rc=lineout('control.scr', 'ssinich="IOPGM.SCR"');
rc=lineout('control.scr', '');
rc=lineout('control.scr', 'ssgroup=9');
rc=lineout('control.scr', 'ssname="GEM Raster I/O Procedure"');
rc=lineout('control.scr', 'sssize=70');
rc=lineout('control.scr', 'ssversion="1.0.0"');
rc=lineout('control.scr', 'ssselect="YES"');
rc=lineout('control.scr', 'ssconfigch="MMIMAGE.SCR"');
rc=lineout('control.scr', 'ssinich="IOGEM.SCR"');
rc=lineout('control.scr', '');
rc=lineout('control.scr', 'ssgroup=10');
rc=lineout('control.scr', 'ssname="OS/2&Windows bitmap I/O Procedure"');
rc=lineout('control.scr', 'sssize=70');
rc=lineout('control.scr', 'ssversion="1.0.0"');
rc=lineout('control.scr', 'ssselect="YES"');
rc=lineout('control.scr', 'ssconfigch="MMIMAGE.SCR"');
rc=lineout('control.scr', 'ssinich="IOBMP.SCR"');
rc=lineout('control.scr', '');
rc=lineout('control.scr', 'ssgroup=11');
rc=lineout('control.scr', 'ssname="IBM KIPS I/O Procedure"');
rc=lineout('control.scr', 'sssize=70');
rc=lineout('control.scr', 'ssversion="1.0.0"');
rc=lineout('control.scr', 'ssselect="YES"');
rc=lineout('control.scr', 'ssconfigch="MMIMAGE.SCR"');
rc=lineout('control.scr', 'ssinich="IOKPS.SCR"');
rc=lineout('control.scr', '');
rc=lineout('control.scr', 'ssgroup=12');
rc=lineout('control.scr', 'ssname="Portrait I/O Procedure"');
rc=lineout('control.scr', 'sssize=70');
rc=lineout('control.scr', 'ssversion="1.0.0"');
rc=lineout('control.scr', 'ssselect="YES"');
rc=lineout('control.scr', 'ssconfigch="MMIMAGE.SCR"');
rc=lineout('control.scr', 'ssinich="IOCVP.SCR"');
rc=lineout('control.scr', '');
rc=lineout('control.scr', 'ssgroup=13');
rc=lineout('control.scr', 'ssname="GIF I/O Procedure"');
rc=lineout('control.scr', 'sssize=70');
rc=lineout('control.scr', 'ssversion="1.1.0"');
rc=lineout('control.scr', 'ssselect="YES"');
rc=lineout('control.scr', 'ssconfigch="MMIMAGE.SCR"');
rc=lineout('control.scr', 'ssinich="IOGIF.SCR"');
rc=lineout('control.scr', '');
rc=lineout('control.scr', 'ssgroup=14');
rc=lineout('control.scr', 'ssname="IBM Image Access eXecutive I/O Procedure"');
rc=lineout('control.scr', 'sssize=70');
rc=lineout('control.scr', 'ssversion="1.0.0"');
rc=lineout('control.scr', 'ssselect="YES"');
rc=lineout('control.scr', 'ssconfigch="MMIMAGE.SCR"');
rc=lineout('control.scr', 'ssinich="IOIAX.SCR"');
rc=lineout('control.scr', '');
rc=lineout('control.scr', 'ssgroup=15');
rc=lineout('control.scr', 'ssname="LBM I/O Procedure"');
rc=lineout('control.scr', 'sssize=70');
rc=lineout('control.scr', 'ssversion="1.0.0"');
rc=lineout('control.scr', 'ssselect="YES"');
rc=lineout('control.scr', 'ssconfigch="MMIMAGE.SCR"');
rc=lineout('control.scr', 'ssinich="IOLBM.SCR"');
rc=lineout('control.scr', '');
rc=lineout('control.scr', 'ssgroup=16');
rc=lineout('control.scr', 'ssname="PCX I/O Procedure"');
rc=lineout('control.scr', 'sssize=70');
rc=lineout('control.scr', 'ssversion="1.0.0"');
rc=lineout('control.scr', 'ssselect="YES"');
rc=lineout('control.scr', 'ssconfigch="MMIMAGE.SCR"');
rc=lineout('control.scr', 'ssinich="IOPCX.SCR"');
rc=lineout('control.scr', '');
rc=lineout('control.scr', 'ssgroup=17');
rc=lineout('control.scr', 'ssname="PSG I/O Procedure"');
rc=lineout('control.scr', 'sssize=70');
rc=lineout('control.scr', 'ssversion="1.0.0"');
rc=lineout('control.scr', 'ssselect="YES"');
rc=lineout('control.scr', 'ssconfigch="MMIMAGE.SCR"');
rc=lineout('control.scr', 'ssinich="IOPSG.SCR"');
rc=lineout('control.scr', '');
rc=lineout('control.scr', 'ssgroup=18');
rc=lineout('control.scr', 'ssname="SPR I/O Procedure"');
rc=lineout('control.scr', 'sssize=70');
rc=lineout('control.scr', 'ssversion="1.0.0"');
rc=lineout('control.scr', 'ssselect="YES"');
rc=lineout('control.scr', 'ssconfigch="MMIMAGE.SCR"');
rc=lineout('control.scr', 'ssinich="IOSPR.SCR"');
rc=lineout('control.scr', '');
rc=lineout('control.scr', 'ssgroup=19');
rc=lineout('control.scr', 'ssname="TGA I/O Procedure"');
rc=lineout('control.scr', 'sssize=70');
rc=lineout('control.scr', 'ssversion="1.0.0"');
rc=lineout('control.scr', 'ssselect="YES"');
rc=lineout('control.scr', 'ssconfigch="MMIMAGE.SCR"');
rc=lineout('control.scr', 'ssinich="IOTGA.SCR"');
rc=lineout('control.scr', '');
rc=lineout('control.scr', 'ssgroup=20');
rc=lineout('control.scr', 'ssname="TIF I/O Procedure"');
rc=lineout('control.scr', 'sssize=70');
rc=lineout('control.scr', 'ssversion="1.0.0"');
rc=lineout('control.scr', 'ssselect="YES"');
rc=lineout('control.scr', 'ssconfigch="MMIMAGE.SCR"');
rc=lineout('control.scr', 'ssinich="IOTIF.SCR"');
rc=lineout('control.scr', '');
rc=lineout('control.scr', 'ssgroup=21');
rc=lineout('control.scr', 'ssname="VID I/O Procedure"');
rc=lineout('control.scr', 'sssize=70');
rc=lineout('control.scr', 'ssversion="1.0.0"');
rc=lineout('control.scr', 'ssselect="YES"');
rc=lineout('control.scr', 'ssconfigch="MMIMAGE.SCR"');
rc=lineout('control.scr', 'ssinich="IOVID.SCR"');
rc=lineout('control.scr', '');
rc=lineout('control.scr', 'ssgroup=22');
rc=lineout('control.scr', 'ssname="WPS Classes"');
rc=lineout('control.scr', 'sssize=70');
rc=lineout('control.scr', 'ssversion="1.0.0"');
rc=lineout('control.scr', 'ssselect="YES"');
rc=lineout('control.scr', 'ssconfigch="MMIMAGE.SCR"');
rc=lineout('control.scr', '');
rc=lineout('control.scr', 'ssgroup=23');
rc=lineout('control.scr', 'ssname="Portable Bit-map I/O Procedure"');
rc=lineout('control.scr', 'sssize=70');
rc=lineout('control.scr', 'ssversion="1.0.0"');
rc=lineout('control.scr', 'ssselect="YES"');
rc=lineout('control.scr', 'ssconfigch="MMIMAGE.SCR"');
rc=lineout('control.scr', 'ssinich="IOPBM.SCR"');
rc=lineout('control.scr', '');
rc=lineout('control.scr', 'ssgroup=24');
rc=lineout('control.scr', 'ssname="Portable Anymap I/O Procedure"');
rc=lineout('control.scr', 'sssize=70');
rc=lineout('control.scr', 'ssversion="1.0.0"');
rc=lineout('control.scr', 'ssselect="YES"');
rc=lineout('control.scr', 'ssconfigch="MMIMAGE.SCR"');
rc=lineout('control.scr', 'ssinich="IOPNM.SCR"');
rc=lineout('control.scr', '');
rc=lineout('control.scr', 'ssgroup=25');
rc=lineout('control.scr', 'ssname="Different support libraries"');
rc=lineout('control.scr', 'sssize=70');
rc=lineout('control.scr', 'ssversion="1.0.0"');
rc=lineout('control.scr', 'ssselect="YES"');
rc=lineout('control.scr', 'ssconfigch="MMIMAGE.SCR"');

rc=stream('control.scr','c','close')


/* 뢠 楤 ⠭ */
'@minstall /R:'||rep||' /F:'||directory()||'\control.scr > nul'
r=rc
'@copy %LOGFILES%\dinst.log+'||mmbase||'\install\minstall.log %LOGFILES%\dinstall.log > nul'
'@del %LOGFILES%\dinst.log > nul'
if R<>-512 then if R<>8 then
do
  call say_log 'Error during MINSTALL. RC='||R
  /*   MINSTALL  KIEWITZ:
    2048 -   response file
  */
/*  signal error */
end

'@if exist '||rep||' @del '||rep||'>nul'
'@del control.scr>nul'
call say_log 'I/O Procedures installed'

/*  窠  , 祣 MINSTALL  㬥  㬥 筮. */
if SysRegisterObjectClass("WPObjectEx","WPOBJEX") then
  call say_log 'WPObjectEx Class Registered'
else
  call say_log 'Error registering WPObjectEx Class'

if SysRegisterObjectClass("WPImageFileEx","WPIMGEX") then
  call say_log 'WPImageFileEx Class Registered'
else
  call say_log 'Error registering WPImageFileEx Class'

if SysRegisterObjectClass("WPFolderEx","WPFLDREX") then
  call say_log 'WPFolderEx Class Registered'
else
  call say_log 'Error registering WPFolderEx Class'

if SysRegisterObjectClass("WPPDF","WPPDF") then
  call say_log 'WPPDF Class Registered'
else
  call say_log 'Error registering WPPDF Class'

if SysRegisterObjectClass("WPDataFileEx","WPDFEX") then
  call say_log 'WPDataFileEx Class Registered'
else
  call say_log 'Error registering WPDataFileEx Class'


if SysIni(USER, "PM_InstallClassReplacement", 'WPObject', 'WPObjectEx') = '' then
  call say_log 'WPObject class replaced by WPObjectEx'
else
  call say_log 'WPObject class replacement error'

if SysIni(USER, "PM_InstallClassReplacement", 'WPDataFile', 'WPDataFileEx') = '' then
  call say_log 'WPDataFile class replaced by WPDataFileEx'
else
  call say_log 'WPDataFile class replacement error'

if SysIni(USER, "PM_InstallClassReplacement", 'WPImageFile', 'WPImageFileEx') = '' then
  call say_log 'WPImageFile class replaced by WPImageFileEx'
else
  call say_log 'WPImageFile class replacement error'

if SysIni(USER, "PM_InstallClassReplacement", 'WPFolder', 'WPFolderEx') = '' then
  call say_log 'WPFolder class replaced by WPFolderEx'
else
  call say_log 'WPFolder class replacement error'

'@copy uninstall.cmd '||osdir||'\INSTALL\BACKUP\ESCHEMES > nul'
'@copy unlock.exe '||osdir||'\INSTALL\BACKUP\ESCHEMES > nul'
If SysCreateObject("WPProgram", "eSchemes Deluxe deinstallation", "<WP_ASDUNINSTFOLDER>","EXENAME="||osdir||"\INSTALL\BACKUP\ESCHEMES\uninstall.cmd;OBJECTID=<DELUXE_UNINST>","U") Then
call say_log 'Deinstallation procedure installed'

call say_log 'Resorting images...'
f='resort.scr'
do while lines(f)>0
  s=strip(linein(f))
  if s<>'' then if (substr(s, 1, 1)<>'#') then
  do
    parse value s with _from '|' _to
    '@if not exist '||mmbase||'\IMAGES\'||_to||'\* @md '||mmbase||'\IMAGES\'||_to||' 2>&1 >NUL'
    '@if exist '||bootdrive||_from||' @copy '||bootdrive||_from||' '||mmbase||'\IMAGES\'||_to||'\ 2>&1 >NUL'
    '@if exist '||bootdrive||_from||' @del '||bootdrive||_from||' 2>&1 >NUL'
  end
end
call say_log 'Image resorting finished.'


/* .  ⮢. */
call say_log ''
call say_log 'Installation finished. Please reboot.'

/*   ⠭ */
'@copy %LOGFILES%\dinstall.log + %LOGFILES%\dinst.log %LOGFILES%\d.log > nul'
'@del %LOGFILES%\dinstall.log > nul'
'@copy %LOGFILES%\d.log %LOGFILES%\dinstall.log > nul'
'@del %LOGFILES%\dinst.log %LOGFILES%\d.log > nul'

return

error:
  call say_log errmsg
  call say_log ''
  call say_log 'Please send bug report and logfile dinstall.log from your'
  call say_log 'logfiles directory to support@ecomstation.ru'
  call say_log ''
  call say_log 'Thank you for your support.'
  call say_log ''

  rc=stream(rep,'c','close')
  '@if exist '||rep||' del '||rep
  rc=stream(tmp2,'c','close')
  rc=stream(tmp,'c','close')
  '@if exist '||tmp2||' del '||tmp2
  '@if exist '||tmp||' del '||tmp
  /*   ⠭ */
  '@copy %LOGFILES%\dinstall.log + %LOGFILES%\dinst.log %LOGFILES%\d.log > nul'
  '@del %LOGFILES%\dinstall.log > nul'
  '@copy %LOGFILES%\d.log %LOGFILES%\dinstall.log > nul'
  '@del %LOGFILES%\dinst.log %LOGFILES%\d.log > nul'
exit

say_log: Procedure
Parse Arg msg
'@echo '||msg||'>>%LOGFILES%\dinst.log'
Say msg
Return
