/* eSchemes Deluxe UnInstallation Procedure */

/* 㦠 SysUtils */
CALL RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
CALL SysLoadFuncs

/* ।塞 ⥬ ⠫  ᪨ */
temp = STRIP(VALUE('TEMP',,'OS2ENVIRONMENT'))
osdir = STRIP(VALUE('OSDIR',,'OS2ENVIRONMENT'))
c = SUBSTR(osdir, 1, 1)

curdir=directory()
if translate(curdir)<>translate(osdir||'\INSTALL\BACKUP\ESCHEMES') then
do
  Say 'This program not aimed to run it manually.'
  Exit
end

/* ।塞 ⠫  㬥 */
mmbase = STRIP(VALUE('MMBASE',,'OS2ENVIRONMENT'))
parse value mmbase with mmbase ';'
if mmbase='' then mmbase=c||':\MMOS2'
mmdir=mmbase||'\DLL\'

/* 饬 ᫥  */
f=''
call SysFileTree osdir||'\INSTALL\BACKUP\ESCHEMES\*', 'file', 'DO'
if file.0=0 then
do
  Say 'eSchemes Deluxe not installed or backup files are destroed'
  '@pause'
  exit
end

do i=1 to file.0
  f=f||filespec('name', file.i)||',';
end

f=substr(f, 1, length(f)-1)
numeric digits 14

interpret('f=max('||f||')')

f=osdir||'\INSTALL\BACKUP\ESCHEMES\'||f

/* 㥬 䠩 ⭮  ⠫ */
'@copy '||f||'\MMPMMMIO.INI '||mmbase||'\MMPMMMIO.INI >nul'
'@unlock '||mmdir||'\* >nul'
'@del '||f||'\MMPMMMIO.INI >nul'
'@copy '||f||'\* '||mmdir||' >nul'
say 'Files from backup copy are restored'

'@del /n '||f||'\* >nul'
'@rd '||f||' >nul'
say 'Backup files are deleted'

/* 饬 WarpIn */
r=SysIni('USER', 'WarpIN', 'Path')
wpidisk=SUBSTR(r, 1, 1);
r=SUBSTR(r, 1, length(r)-1)||'\DATBAS_'||wpidisk||'.INI'
rc=SysIni(r, 'All:', 'P.')
flag=0
do i=0 to P.0
  if pos('eCo Software\eDesktop\eFolder\', p.i) > 0 then flag=1
end

if flag=1 then
do
  Say 'Another eFolder installation detected. Not deregistering eFolder classes.'
end
else
do
  /*   㤠塞, ⮫쪮 ᫨  ⠭ eSchemes  PCM */
  /*  eFolder c PackageID eCo Software\eDesktop\eFolder\ */
  Call SysDeregisterObjectClass "WPFolderEx"
  Call SysDeregisterObjectClass "WPObjectEx"
end

/*   ⠢ ⮫쪮 , ᥬ  ᬥ  㤠 */
Call SysDeregisterObjectClass "WPImageFileEx"
Call SysDeregisterObjectClass "WPDataFileEx"
Call SysDeregisterObjectClass "WPPDF"

'@pause'

exit

